		;;@
		;;@
		;;@		C P C - A Y   S T E R E O - S A M P L E - P L A Y E R
		;;@
		;;@		(c) 2019 by Prodatron / SymbiosiS (Jrn Mika)
		;;@		And Devilmarkus (Markus Hohmann)
		;;@
		;;@

		org		#9000
		;;write		direct "a:code.bin"

		TXT_OUTPUT		equ #BB5A

start:
		LD		a,#c9
		LD		(start),a ;; prevent reinit

		LD		HL,BufferRsx
		LD		BC,PtrRsx
		JP		#BCD1

BufferRsx:
		DS		4

PtrRsx:
		DW		RSX_TABLE
		JP		SetBank
		JP		playsample
		JP		playclip
		JP		setspeed
		JP		14khz
		JP		12khz
		JP		11khz
		JP		8khz
		JP		6khz
		JP		5_5khz
		JP		4khz
		JP		info_message
RSX_TABLE:
		DB		"PLAYBAN","K"+#80
		DB		"PLAYSAMPL","E"+#80
		DB		"PLAYCLI","P"+#80
		DB		"PLAYSPEE","D"+#80
		DB		"FREQ.1","4"+#80
		DB		"FREQ.1","2"+#80
		DB		"FREQ.1","1"+#80
		DB		"FREQ.","8"+#80
		DB		"FREQ.","6"+#80
		DB		"FREQ.5.","5"+#80
		DB		"FREQ.","4"+#80
		DB		"PLAYERHEL","P"+#80
		DB		0

info_message
		ld		a,1
		call		&bc0e
		LD		HL,MESSAGE ; Zeiger auf Fehler-Text
		CALL		MESSPRI
		RET
MESSPRI		;HL=ZEIGER             ;GIBT TEXTE AUS
		LD		A,(HL)
		OR		A
		RET		Z
		INC		HL
		CALL		TXT_OUTPUT
		JR		MESSPRI
		ret

MESSAGE
		DB		15,3,"****************************************"
		DB		15,3,"*      ",15,2,"Stereo Sampleplayer ",164," 2020",15,3,"      *"
		DB		15,3,"*        ",15,1,"Prodatron of SymbiosiS",15,3,"        *"
		DB		15,3,"*           ",15,1,"and Devilmarkus",15,3,"            *"
		DB		15,3,"****************************************",13,10
		DB		15,3,"Commands:",13,10,13,10
		DB		15,1,"|PLAYERHELP - This info",13,10
		DB		15,1,"|PLAYSPEED,<speed> - set speed 1-255",13,10
		DB		15,1,"|FREQ.<frequency> - set accurate speed",13,10
		db		15,2,"Possible values are: 14,12,11,8,6,5.5,4",13,10
		DB		15,3,"Example: |FREQ.12 - Set player to 12khz",13,10
		DB		15,1,"|PLAYBANK,<bank> - set RAM bank 0-256",13,10
		DB		15,1,"|PLAYSAMPLE,<startbank>,<size>",13,10
		DB		15,2,"<size> is the number of banks to play",13,10
		DB		15,1,"|PLAYCLIP,<startaddress>,<length>",13,10,13,10,0

SHORTMESSAGE
		DB		"Samplesize too small, min. 768",7,13,10,0
LARGEMESSAGE
		DB		"Samplesize too large, max. 16384",7,13,10,0
ADDRESSLOW
		DB		"Start address error, min. &4000",7,13,10,0
ADDRESSHIGH
		DB		"Start address error, max. &7CFF",7,13,10,0
ERRORMESSAGE
		DB		"Bank out of range",7,13,10,0
RANGEMESSAGE
		DB		"Speed out of range",7,13,10,0
PLERRORMESSAGE
		DB		"Command error - |PLAYERHELP for help",7,13,10,0
setspeed:		
		cp		1
		jp		nz,PlayError ; Quit if no parameter supplied (could add error handling)
		
		ld		c,(ix+0)
		ld		b,(ix+1)
		ld		hl,255 ; Get the Maximum Speed Count
		sbc		hl,bc
		jp		c,OutOfRange
		
		ld		hl,0 ; Get the minimum sampleaddress
		sbc		hl,bc
		jp		nc,OutOfRange
		ld		a,(ix+0)
		ld		(speedbuffer),a
		ret
14khz:
		ld		a,1
		ld		(speedbuffer),a
		ret
12khz:
		ld		a,6
		ld		(speedbuffer),a
		ret
11khz:
		ld		a,10
		ld		(speedbuffer),a
		ret
8khz:
		ld		a,27
		ld		(speedbuffer),a
		ret
6khz:
		ld		a,47
		ld		(speedbuffer),a
		ret
5_5khz:
		ld		a,54
		ld		(speedbuffer),a
		ret
4khz:
		ld		a,89
		ld		(speedbuffer),a
		ret

TooShort:
		LD		HL,SHORTMESSAGE ; Zeiger auf Fehler-Text
		CALL		MESSPRI
		RET
TooLarge:
		LD		HL,LARGEMESSAGE ; Zeiger auf Fehler-Text
		CALL		MESSPRI
		RET
AddressTooLow:
		LD		HL,ADDRESSLOW ; Zeiger auf Fehler-Text
		CALL		MESSPRI
		RET
AddressTooHigh:
		LD		HL,ADDRESSHIGH ; Zeiger auf Fehler-Text
		CALL		MESSPRI
		RET
BankOutOfRange:
		LD		HL,ERRORMESSAGE ; Zeiger auf Fehler-Text
		CALL		MESSPRI
		RET
OutOfRange:
		LD		HL,RANGEMESSAGE ; Zeiger auf Fehler-Text
		CALL		MESSPRI
		RET
PlayError:
		LD		HL,PLERRORMESSAGE ; Zeiger auf Fehler-Text
		CALL		MESSPRI
		RET
SetBank:
		cp		1
		jp		nz,PlayError ; Quit if no parameter supplied (could add error handling)
		ld		c,(ix+0)
		ld		b,(ix+1)   ; Get Bank Number Passed in Parameter
BankOffsetCalc:
		ld		hl,256 ; Get the Maximum Bank Count
		sbc		hl,bc
		jr		c,BankOutOfRange ; Quit if we're requesting an invalid bank
		LD		HL,4mb_banks  ; Point to Table
		add		hl,bc
		add		hl,bc   ; Add 2 * BC to HL to point to correct word
		ld		C,(HL)
		inc		HL
		ld		B,(HL)          ; Get Port Number

		ld		a,b
		or		c
		ret		z    ; Safety Check Quit if Zero Word Selected
		out		(C),C  ; Switch the bank in
		ret
samplesize:
		ds		2

playclip:
		cp		2
		jp		nz,PlayError
		ld		c,(ix+2)
		ld		b,(ix+3)
		ld		hl,&3fff ; Get the minimum sampleaddress
		sbc		hl,bc
		jp		nc,AddressTooLow
		ld		hl,&7D00 ; Get the maximum sampleaddress
		sbc		hl,bc
		jp		c,AddressTooHigh
		ld		c,(ix+0)
		ld		b,(ix+1)
		ld		hl,767 ; Get the minimum samplesize
		sbc		hl,bc
		jp		nc,TooShort
		ld		hl,&4001 ; Get the maximum samplesize
		sbc		hl,bc
		jp		c,TooLarge
psg2clip
		ld hl,&4000
		ld		(psg2clip1+1),hl
		di		;lock interrupts
		exx
		ex		af,af'
		push		af
		push		bc             ;save 2nd register set
		push		de
		push		hl
		ld		bc,#f6c0         ;prepare 2nd register set
		ld		de,#0f80
		exx
		ld		(psg2clip5+1),sp   ;save stackpointer

psg2clip1
		ld		d,(ix+0)
		ld		e,(ix+1)
		scf
		ccf
		rr		D
		rr		E
		ld		l,(ix+2)
		ld		h,(ix+3)
		ld		sp,hl
		ld		bc,#f401
		ld		hl,10*256+8
psg2clip2		;*** SAMPLE LOOP
		out		(c),l           ;4      L=channel A
		exx		;1
		pop		hl              ;3      HL'=next 2 bytes
		ld		a,l              ;1      1st byte lower nibble (left channel)
		and		d               ;1      D'=15
		out		(c),c           ;4
		out		(c),0          ;4      out (c),0
		exx		;1
		out		(c),a           ;4
		exx		;1
		out		(c),e           ;4
		out		(c),0          ;4
		exx		;1 33

		out		(c),h           ;4      H=channel B
		exx		;1
		ld		a,(speedbuffer)
clippause
		dec		a
		jp		nz,clippause
		xor		a
		ld		a,l              ;1      1st byte higher nibble (right channel)
		;		*** RETMOD ***
		cp		&FF
		jp		z,psg2clip5
		;		*** RETMOD ***
		rrca:rrca:rrca:rrca		;4
		and		d               ;1
		out		(c),c           ;4
		out		(c),0          ;4
		exx		;1
		out		(c),a           ;4
		exx		;1
		out		(c),e           ;4
		out		(c),0          ;4
		exx		;1 34

		out		(c),l           ;4
		exx		;1
		ld		a,h              ;1      2nd byte lower nibble (left channel)
		and		d               ;1
		out		(c),c           ;4
		out		(c),0          ;4
		exx		;1
		out		(c),a           ;4
		exx		;1
		out		(c),e           ;4
		out		(c),0          ;4
		exx		;1 30

		out		(c),h           ;4
		exx		;1
		out		(c),c           ;4
		out		(c),0          ;4
		ld		a,h              ;1      2nd byte higher nibble (right channel)
		rrca
		rrca
		rrca
		rrca		;4
		and		d               ;1
		exx		;1
		out		(c),a           ;4
		exx		;1
		out		(c),e           ;4
		out		(c),0          ;4
		exx		;1 34

		dec		e               ;1      next samples
		jp		nz,psg2clip2       ;3 -> 33+34+30+34+4 = 135 -> 67,5nops/sample -> 14,8kHz sample rate

		ld		iy,psgcol
		ld		(ixbuffer),ix
		ld		ix,psgcolb
		exx		;1
		ex		af,af'           ;1
		ld		a,h              ;1
		and		d               ;1
		exx		;1  a'=left,a=right
		ld		b,#7f            ;2
		out		(c),c           ;4
		ld		(psgclipcol1+2),a    ;4
psgclipcol1
		ld		a,(iy+0)         ;5
		out		(c),a           ;4
		inc		c               ;1
		out		(c),c           ;4
		ex		af,af'           ;1
		ld		(psgclipcol2+2),a    ;4
psgclipcol2
		ld		a,(ix+0)         ;5
		out		(c),a           ;4
		dec		c               ;1
		;		ld b,#f4            ;2 46 / 256 = 0,18nops (insignificant)

		ld		a,#48            ;2
		ld		bc,#f782         ;3
		out		(c),c           ;4
		ld		bc,#f40e         ;3
		out		(c),c           ;4
		ld		bc,#f6c0         ;3
		out		(c),c           ;4
		out		(c),0          ;4
		ld		bc,#f792         ;3
		out		(c),c           ;4
		dec		b               ;1
		out		(c),a           ;4
		ld		b,#f4            ;2
		in		a,(c)            ;4
		ld		bc,#f782         ;3
		out		(c),c           ;4
		ld		bc,#f401         ;3
		bit		2,a             ;2

		jp		z,psg2clip5        ;2 59 / 16384 = insignificant

		ld		ix,(ixbuffer)
		dec		d
		jp		nz,psg2clip2


psg2clip5
		ld		sp,0             ;finished -> restore stack and 2nd register set
		exx
		pop		hl
		pop		de
		pop		bc
		pop		af
		ex		af,af'
		exx
		ei
		ret


playsample:
		cp		2
		jp		nz,PlayError
		ld		c,(ix+2)
		ld		b,(ix+3)
		ld		hl,256 ; Get the Maximum Bank Count
		sbc		hl,bc
		jp		c,BankOutOfRange
		ld		hl,4mb_banks
		add		hl,bc
		add		hl,bc
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ex		de,hl
		ld		e,(ix+0)
		ld		d,(ix+1)
		push		hl
		ld		hl,256 ; Get the Maximum Bank Count
		or		a
		sbc		hl,bc
		sbc		hl,de
		jp		c,BankOutOfRange
		pop		hl
		push		de
		pop		ix
		call		psgini
		call		psg2ch
		ret


		;###		PSG2CH -> PSG Stereo sample player
		;###		Input      HL=start banking config, IX=number of 16K blocks (0-256)
		;###		Destroyed  AF,BC,DE,HL,IXL
psg2ch
		ld		(psg2ch1+1),hl
		di		;lock interrupts
		exx
		ex		af,af'
		push		af
		push		bc             ;save 2nd register set
		push		de
		push		hl
		ld		bc,#f6c0         ;prepare 2nd register set
		ld		de,#0f80
		exx
		ld		(psg2ch5+1),sp   ;save stackpointer

psg2ch1
		ld		bc,0                 ;*** BANKING LOOP
		out		(c),c
		ld		sp,#4000
		ld		de,32*256        ;32*256=8192 16bit loops (=16384 8bit samples)
		ld		bc,#f401
		ld		hl,10*256+8
psg2ch2		;*** SAMPLE LOOP
		out		(c),l           ;4      L=channel A
		exx		;1
		pop		hl              ;3      HL'=next 2 bytes
		ld		a,l              ;1      1st byte lower nibble (left channel)
		and		d               ;1      D'=15
		out		(c),c           ;4
		out		(c),0          ;4      out (c),0
		exx		;1
		out		(c),a           ;4
		exx		;1
		out		(c),e           ;4
		out		(c),0          ;4
		exx		;1 33

		out		(c),h           ;4      H=channel B
		exx		;1
		ld		a,(speedbuffer)
looppause
		dec		a
		jp		nz,looppause
		xor		a
		ld		a,l              ;1      1st byte higher nibble (right channel)
		;		*** RETMOD ***
		cp		&FF
		jp		z,psg2ch5
		;		*** RETMOD ***
		rrca:rrca:rrca:rrca		;4
		and		d               ;1
		out		(c),c           ;4
		out		(c),0          ;4
		exx		;1
		out		(c),a           ;4
		exx		;1
		out		(c),e           ;4
		out		(c),0          ;4
		exx		;1 34

		out		(c),l           ;4
		exx		;1
		ld		a,h              ;1      2nd byte lower nibble (left channel)
		and		d               ;1
		out		(c),c           ;4
		out		(c),0          ;4
		exx		;1
		out		(c),a           ;4
		exx		;1
		out		(c),e           ;4
		out		(c),0          ;4
		exx		;1 30

		out		(c),h           ;4
		exx		;1
		out		(c),c           ;4
		out		(c),0          ;4
		ld		a,h              ;1      2nd byte higher nibble (right channel)
		rrca
		rrca
		rrca
		rrca		;4
		and		d               ;1
		exx		;1
		out		(c),a           ;4
		exx		;1
		out		(c),e           ;4
		out		(c),0          ;4
		exx		;1 34

		dec		e               ;1      next samples
		jp		nz,psg2ch2       ;3 -> 33+34+30+34+4 = 135 -> 67,5nops/sample -> 14,8kHz sample rate

		ld		iy,psgcol
		ld		(ixbuffer),ix
		ld		ix,psgcolb
		exx		;1
		ex		af,af'           ;1
		ld		a,h              ;1
		and		d               ;1
		exx		;1  a'=left,a=right
		ld		b,#7f            ;2
		out		(c),c           ;4
		ld		(psgcol1+2),a    ;4
psgcol1
		ld		a,(iy+0)         ;5
		out		(c),a           ;4
		inc		c               ;1
		out		(c),c           ;4
		ex		af,af'           ;1
		ld		(psgcol2+2),a    ;4
psgcol2
		ld		a,(ix+0)         ;5
		out		(c),a           ;4
		dec		c               ;1
		;		ld b,#f4            ;2 46 / 256 = 0,18nops (insignificant)

		ld		a,#48            ;2
		ld		bc,#f782         ;3
		out		(c),c           ;4
		ld		bc,#f40e         ;3
		out		(c),c           ;4
		ld		bc,#f6c0         ;3
		out		(c),c           ;4
		out		(c),0          ;4
		ld		bc,#f792         ;3
		out		(c),c           ;4
		dec		b               ;1
		out		(c),a           ;4
		ld		b,#f4            ;2
		in		a,(c)            ;4
		ld		bc,#f782         ;3
		out		(c),c           ;4
		ld		bc,#f401         ;3
		bit		2,a             ;2

		jp		z,psg2ch5        ;2 59 / 16384 = insignificant

		ld		ix,(ixbuffer)
		dec		d
		jp		nz,psg2ch2

		dec		lx        ;next 16K memory block
		jr		z,psg2ch5
		ld		hl,psg2ch1+1
		ld		a,(hl)
		cp		#c0
		jp		nz,notc0
		ld		a,#c3
notc0
		inc		a
		jp		z,psg2ch4
		bit		2,a
		jp		nz,psg2ch3
		add		4               ;next 64K memory bank
psg2ch3
		ld		(hl),a

		jp		psg2ch1
psg2ch4
		ld		(hl),#c4         ;next 512K memory segment
		inc		hl
		dec		(hl)
		jp		psg2ch1

psg2ch5
		ld		sp,0             ;finished -> restore stack and 2nd register set
		exx
		pop		hl
		pop		de
		pop		bc
		pop		af
		ex		af,af'
		exx
		ei
		ret


		;###		PSGREG -> sets PSG register
		;###		Input      A=register, E=value
		;###		Destroyed  BC
psgreg
		ld		b,#f4
		out		(c),a
		ld		bc,#f6c0
		out		(c),c
		out		(c),0
		ld		b,#f4
		out		(c),e
		ld		bc,#f680
		out		(c),c
		out		(c),0
		ret

		;###		PSGINI -> Resets PSG
		;###		Destroyed  AF,BC,E
psgini
		xor		a
		ld		e,a
psgini1		
		call psgreg
		inc		a
		cp		13
		jr		c,psgini1
		ld		a,7
		ld		e,#3f
		jp		psgreg

		;###		PSGCOL -> Color table for left/right channel VU meter
psgcol
		;		0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
		;		100                                               0  33  66 100
		db		#4b,#4b,#5b,#5b,#53,#53,#57,#5f,#55,#44,#54,#55,#5b,#4b,#4b,#4b  ;blue
psgcolb
		;		0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
		;		100                                               0  33  66 100
		db		#4b,#4b,#43,#4a,#4e,#4e,#4d,#45,#4c,#5c,#54,#4c,#4a,#4b,#4b,#4b  ;blue

4mb_banks:

		dw		&7FC0, &7FC4, &7FC5, &7FC6, &7FC7, &7FCC, &7FCD, &7FCE, &7FCF, &7FD4
		dw		&7FD5, &7FD6, &7FD7, &7FDC, &7FDD, &7FDE, &7FDF, &7FE4, &7FE5, &7FE6
		dw		&7FE7, &7FEC, &7FED, &7FEE, &7FEF, &7FF4, &7FF5, &7FF6, &7FF7, &7FFC
		dw		&7FFD, &7FFE, &7FFF, &7EC4, &7EC5, &7EC6, &7EC7, &7ECC, &7ECD, &7ECE
		dw		&7ECF, &7ED4, &7ED5, &7ED6, &7ED7, &7EDC, &7EDD, &7EDE, &7EDF, &7EE4
		dw		&7EE5, &7EE6, &7EE7, &7EEC, &7EED, &7EEE, &7EEF, &7EF4, &7EF5, &7EF6
		dw		&7EF7, &7EFC, &7EFD, &7EFE, &7EFF, &7DC4, &7DC5, &7DC6, &7DC7, &7DCC
		dw		&7DCD, &7DCE, &7DCF, &7DD4, &7DD5, &7DD6, &7DD7, &7DDC, &7DDD, &7DDE
		dw		&7DDF, &7DE4, &7DE5, &7DE6, &7DE7, &7DEC, &7DED, &7DEE, &7DEF, &7DF4
		dw		&7DF5, &7DF6, &7DF7, &7DFC, &7DFD, &7DFE, &7DFF, &7CC4, &7CC5, &7CC6
		dw		&7CC7, &7CCC, &7CCD, &7CCE, &7CCF, &7CD4, &7CD5, &7CD6, &7CD7, &7CDC
		dw		&7CDD, &7CDE, &7CDF, &7CE4, &7CE5, &7CE6, &7CE7, &7CEC, &7CED, &7CEE
		dw		&7CEF, &7CF4, &7CF5, &7CF6, &7CF7, &7CFC, &7CFD, &7CFE, &7CFF, &7BC4
		dw		&7BC5, &7BC6, &7BC7, &7BCC, &7BCD, &7BCE, &7BCF, &7BD4, &7BD5, &7BD6
		dw		&7BD7, &7BDC, &7BDD, &7BDE, &7BDF, &7BE4, &7BE5, &7BE6, &7BE7, &7BEC
		dw		&7BED, &7BEE, &7BEF, &7BF4, &7BF5, &7BF6, &7BF7, &7BFC, &7BFD, &7BFE
		dw		&7BFF, &7AC4, &7AC5, &7AC6, &7AC7, &7ACC, &7ACD, &7ACE, &7ACF, &7AD4
		dw		&7AD5, &7AD6, &7AD7, &7ADC, &7ADD, &7ADE, &7ADF, &7AE4, &7AE5, &7AE6
		dw		&7AE7, &7AEC, &7AED, &7AEE, &7AEF, &7AF4, &7AF5, &7AF6, &7AF7, &7AFC
		dw		&7AFD, &7AFE, &7AFF, &79C4, &79C5, &79C6, &79C7, &79CC, &79CD, &79CE
		dw		&79CF, &79D4, &79D5, &79D6, &79D7, &79DC, &79DD, &79DE, &79DF, &79E4
		dw		&79E5, &79E6, &79E7, &79EC, &79ED, &79EE, &79EF, &79F4, &79F5, &79F6
		dw		&79F7, &79FC, &79FD, &79FE, &79FF, &78C4, &78C5, &78C6, &78C7, &78CC
		dw		&78CD, &78CE, &78CF, &78D4, &78D5, &78D6, &78D7, &78DC, &78DD, &78DE
		dw		&78DF, &78E4, &78E5, &78E6, &78E7, &78EC, &78ED, &78EE, &78EF, &78F4
		dw		&78F5, &78F6, &78F7, &78FC, &78FD, &78FE, &78FF
		DW		0 ; Signify End of list DO NOT REMOVE

ixbuffer:
		ds		2
speedbuffer:
		db		1
